function [ verNums, horNums ] = getNumbers(I, m, n, horInterval, verInterval, horLines,  verLines , showResult)
    load('N.mat');
    
    % resizing templates
    numHorSize = 2 * horInterval / 3 + 1;
    resizedN = zeros(9, numHorSize, numHorSize * sizey / sizex);
    for i=1:9
        tempn = cropZeros(squeeze(N(i,:,:)));
        nverfactor = numHorSize * size(tempn, 2) / size(tempn, 1) ;
        temprn = imresize(tempn, [numHorSize, nverfactor]);
        temprn = double(temprn > 0.5);
        temprn = temprn / sum(sum(temprn));
        resizedN(i,1:size(temprn,1), 1:size(temprn,2)) = temprn;
    end

    NI = 256-I;
    thresh = 100;
    nhood = [2*numHorSize , 2*numHorSize];

    % OCR for row numbers
    % OCR for row numbers - initiating
    verNums = zeros(m, ceil(horLines(1) / horInterval)) -1;
    mostNumsOnRow = ceil(verLines(1) / verInterval);
    horSpacing = verInterval / 7;
    numRowSpace = verLines(1) / mostNumsOnRow;

    % OCR for row numbers - iterating
    for row = 1:(length(horLines) - 1)
        zone = NI(horLines(row)+horSpacing:horLines(row+1)-horSpacing, 1:verLines(1)-horSpacing);
        bestScore = zeros(mostNumsOnRow);
        for i=1:9
            nn = cropZeros(squeeze(resizedN(i,:,:)));
            res = conv2(zone,nn, 'same');
            [x1 y1 hnew] = peaks(res, thresh, nhood, mostNumsOnRow);
            a = [y1 x1];
            a = sortrows(reshape(a, length(x1), 2));
            for j=1:length(x1)
                if a(j,2)>  2* horSpacing && a(j,2) < 5 * horSpacing
                    pos = round(a(j,1) /numRowSpace);
                    if res(a(j,2), a(j,1)) > bestScore(pos)
                        bestScore(pos) = res(a(j,2), a(j,1));
                        verNums(row, pos) = i;
                    end
                end
            end
        end
    end

    % OCR for column numbers
    % OCR for column numbers - initiating
    horNums = zeros(ceil(verLines(1) / verInterval), n) -1;
    mostNumsOnCol = ceil((horLines(1)) / horInterval);
    verSpacing = horInterval / 7;
    numColSpace = (horLines(1) -2) / mostNumsOnCol;

    % OCR for column numbers - iterating
    for col = 1: (length(verLines) - 1)
        zone = NI(2:horLines(1)-horSpacing, verLines(col)+horSpacing:verLines(col+1)-horSpacing);
        bestScore = zeros(1,mostNumsOnCol);
        for i=1:9
            nn = cropZeros(squeeze(resizedN(i,:,:)));
            res = conv2(zone,nn, 'same');
            [x1 y1 hnew] = peaks(res, thresh, nhood, mostNumsOnCol);
            a = [x1 y1];
            a = sortrows(reshape(a, length(x1), 2));
            for j=1:length(x1)
                if a(j,2)>  2* verSpacing && a(j,2) < 5 * verSpacing
                    pos = ceil(a(j,1) /numColSpace);
                    if res(a(j,1), a(j,2)) > bestScore(pos)
                        bestScore(pos) = res(a(j,1), a(j,2));
                        horNums(pos,col) = i;
                    end
                end
            end
        end
    end

    if showResult == 1
        showGrid2(ones(size(I,1), size(I,2)), horLines, verLines, 1);
        for r=1:length(verNums)
            for c=1:mostNumsOnRow
                if verNums(r,c) >0
                    text(numRowSpace * (c-1), (horLines(r)+horLines(r+1))/2, num2str(verNums(r,c)), 'LineWidth', 10,'Color','k');
                end
            end
        end
        for c=1:size(horNums,2)
            for r=1:mostNumsOnCol
                if horNums( r,c) >0
                    text((verLines(c)+verLines(c+1))/2, (numColSpace-2) * (r), num2str(horNums(r,c)), 'LineWidth', 10,'Color','k');
                end
            end
        end
    end
end

