function [ bestDeg, P1, P2 ] = bestOrByBins( H, theta, n, m, degsBin, tol )
% input:
% H - output of hough(BW)
% n - number of rows
% m - number of columns
% degsBin - degrees wich will be tested
% tol - tolerance
% output:
% bestDeg - degree of best rotation for m vertical and n horizontal lines.
% P1 - peaks vector of horizonatl lines
% P2 - peaks vector of vertical lines

bests= -1;
bestDeg = -1;
for deg = degsBin
    
    ind =thetaIndByDeg(theta, deg, tol);
    [R, C, hnew] = houghPeaksByTheta(H, ind ,n);%, 120);%, [25 25]);%,'threshold',ceil(0.3*max(H(:))));
    ind2 = thetaIndByDeg(theta, deg+90, tol);
    [R2, C2, hnew] = houghPeaksByTheta(H, ind2 ,m);%, 120);%, [25 25]);%,'threshold',ceil(0.3*max(H(:))));
    s = (sumHoughbyTR(H, R, C) / m);
    s = s + (sumHoughbyTR(H, R2, C2) /n );
    if s > bests & length(R)>0 & length(R2)>0
        bests = s;
        bestDeg = deg;
        bestR = R;
        bestC = C;
        bestR2 = R2;
        bestC2 = C2;
    end
end

% zipping
P1 = zeros(length(bestR), 2);
P1(:,1) = bestR;
P1(:,2) = bestC;

P2 = zeros(length(bestR2), 2);
P2(:,1) = bestR2;
P2(:,2) = bestC2;

end

