function [ horLines, verLines, horInterval, verInterval ] = fixGrid( I, lines1, lines2, n, m )
    [GridYStart,GridXStart]  = biggestWhiteBox(I);
    maxx = size(I, 2) - 1;
    maxy = size(I, 1) - 1;
    
    ax = [];
    for i = lines1
        ax(end+1) = i.point1(1);
    end
    ax = unique(ax);
    ax1 = sort(ax);
    % removing false lines
    ax1 = ax1(find(ax1 > (GridXStart -3)));
    axdif  = zeros(1,length(ax1)-1);
    for i = 2:length(ax1)
        axdif(i-1) = ax1(i) - ax1(i-1);
    end
    
    cy = [];
    for i = lines2
        cy(end+1) = i.point1(2);        
    end
    cy = unique(cy);
    cy1 = sort(cy);
    % removing false lines
    cy1 = cy1(find(cy1 > (GridYStart -3)));
    cydif  = zeros(1,length(cy1)-1);
    for i = 2:length(cy1)
        cydif(i-1) = cy1(i) - cy1(i-1);
    end
    
    % determining horizontal and vertical intervals
    maxHorInt = (maxy - GridYStart) / n ;
    maxVerInt = (maxx - GridXStart) / m ;
    horInterval = mode(cydif);
    verInterval = mode(axdif);
    while horInterval > maxHorInt
        horInterval = mode(cydif(find(cydif < horInterval)));
    end
    while verInterval > maxVerInt
        verInterval = mode(axdif(find(axdif < verInterval)));
    end
    if ~(horInterval > 0)
        horInterval = maxHorInt;
    end
    if ~(verInterval > 0)
        verInterval = maxVerInt;
    end
    % removing too close lines
    ax1(find(axdif < verInterval)) = [];
    cy1(find(cydif < horInterval)) = [];
    
     % takes (x+1) lines to create x rows/colomns
    n = n+1;
    m = m+1;
    
    % Horizontal Lines Fixing
    horLines = [];
    
    % Horizontal Lines - filling gaps
    for i = 1:length(cy1)-1
        horLines(end+1) = cy1(i);
        times = round(cydif(i) / (horInterval -1));
        tempInt = round(cydif(i) / times);
        for j = 1:(times - 1)
            horLines(end+1) = (cy1(i) + ((cydif(i) / times) * j));
        end
    end
    horLines(end+1) = cy1(end);
    
    % Horizontal Lines - adding lines upwards
    for i = 1: n-length(horLines) +1
        new = horLines(1) - horInterval;
        if new > GridYStart - 3
            if new < GridYStart +1
                new = GridYStart + 1;
            end
            horLines = [new, horLines];
        end
    end

    % Horizontal Lines -  adding lines downwards
    for i = 1: n-length(horLines) +1
        new = horLines(end) + horInterval;
        if new < maxy + 3
            if new > maxy
                new = maxy -1;
            end
            horLines = [horLines, new];
        end
    end
    
    % Vertical Lines Fixing
    verLines = [];
    
    % Vertical Lines - filling gaps
    for i = 1:length(ax1)-1
        verLines(end+1) = ax1(i);
        times = round(axdif(i) / (verInterval -1));
        tempInt = round(axdif(i) / times);
        for j = 1:(times - 1)
            verLines(end+1) = (ax1(i) + (tempInt * j));
        end
    end
    verLines(end+1) = ax1(end);
    
    % Vertical Lines - adding lines leftwards
    for i = 1: m-length(verLines) +1
        new = verLines(1) - verInterval;
        if new > GridXStart - 3
            if new < GridXStart +1
                new = GridXStart + 1;
            end
            verLines = [new, verLines];
        end
    end
    
    % Vertical Lines -  adding lines rightwards
    for i = 1:(m-length(horLines)) +1
        new = verLines(end) + verInterval
        if new < maxx + 3
            if new > maxx
                new = maxx -1;
            end
            verLines = [verLines, new];
        end
    end
    while length(verLines) > m
        difs = verLines(2:size(verLines,2)) - verLines(1:size(verLines,2)-1);
        indx = find(difs == min(difs));
        indx = indx(1);
        verLines(indx+1) = [];
    end
    
end
