function [ y ] = imrotateWhiteBg( x, deg )
% rotates image x by deg degrees with white bg
    m = min(x(:));
    x = x - m + 1; % set minimum to one
    y = imrotate(x, deg);
    mask = y ~= 0; % find all non-black pixels
    y(mask) = y(mask) + m;
    y(~mask) = 255; % set black pixels to white

end

