function [ x y h] = peaks( map , threshold,  nhood, numpeaks)
h = map;
if nargin < 4
    numpeaks = 100;
end

if nargin < 3
    nhood = size(h)/50;
end
nhood(1) = nhood(1) - mod(nhood(1), 2) + 1;
nhood(2) = nhood(2) - mod(nhood(2), 2) + 1;

if nargin < 2
    threshold = 0.5 * max(h(:));
end

x = [];
y = [];

done = false;
while ~done
    if max(h(:))
        [p, q] = find(h == max(h(:)));
        p = p(1); q = q(1);
       if h(p, q) >= threshold
            x(end + 1) = p; 
            y(end + 1) = q;
           %end

          % Suppress this maximum and its close neighbors.
          p1 = p - (nhood(1) - 1)/2; p2 = p + (nhood(1) - 1)/2;
          q1 = q - (nhood(2) - 1)/2; q2 = q + (nhood(2) - 1)/2;
          [pp, qq] = ndgrid(p1:p2,q1:q2);
          pp = pp(:); qq = qq(:);

          % Throw away neighbor coordinates that are out of bounds in
          % the x direction.
          badx = find((pp < 1) | (pp > size(h, 1)));
          pp(badx) = []; qq(badx) = [];

          % For coordinates that are out of bounds in the y
          % direction
          bady = find((qq < 1) | (qq > size(h,2)));
          pp(bady) = []; qq(bady) = [];

          % Convert to linear indices to zero out all the values.
          h(sub2ind(size(h), pp, qq)) = 0;
          done = length(x) == numpeaks;
          
       else
          done = true;
       end
   else
          done = true;
    end
end